//+------------------------------------------------------------------+
//|                                              Volatility Bars.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Shaun Overton, www.onestepremoved.com"
#property link      "www.onestepremoved.com"

#property indicator_separate_window
#property  indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 White
#property indicator_color3 White

extern   int   Lookback          =  300;

double vols[], upper[], lower[];

int init()  {
   
   IndicatorDigits(8);
   IndicatorShortName("Volatility");
   
   SetIndexBuffer(0,vols);
   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID, 1, Red);
   SetIndexLabel(0,"Vols");
   
   SetIndexBuffer(1,upper);
   SetIndexStyle(1,DRAW_LINE, STYLE_DASH, 1, White);
   SetIndexLabel(1,"Upper");

   SetIndexBuffer(2,lower);
   SetIndexStyle(2,DRAW_LINE, STYLE_DASH, 1, White);
   SetIndexLabel(2,"Lower");
         
   return(0);
  }

int deinit()
  {

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    remaining_bars= Bars - IndicatorCounted() - 1;
   
   if( Bars - 1 < Lookback ) {
      Comment("There are not enough bars on the chart");
      return( 0 );
   }
   
   double sum = 0;
   double average, temp, divisor;
   double variance = 0;
   
   string show = "";
   
   for( int i = 0; i <= remaining_bars; i++) {
     
      sum = 0;
      
      for( int j = i; j < i + Lookback; j++ ) 
         sum += Close[j]-Close[j+1];         
      
      if( Lookback != 0 )
         average = sum / Lookback;         
        
      for( int k = i; k < i + Lookback; k++) {
      
         temp = (Close[k]-Close[k+1])/Close[k];
         variance += MathPow(temp-average,2);
      }
      
      
      divisor = Lookback-1;
      variance = variance / divisor;
       
      double sdev = MathSqrt(variance);
      
      upper[i] = 2.0;
      lower[i] = -2.0;
      
      vols[i] = ( (Close[i]-Close[i+1]) / Close[i] ) / sdev;
      
      //vols[i] = sdev;
   }
   
   Comment( show );
   
   return(0);
  }
//+------------------------------------------------------------------+